import re
import random
import threading
from flask import jsonify, request, current_app
from flask_mail import Mail, Message
from apps import redis_store, creat_app
from apps.view_mobile import api_mobile
from apps.models import *
from apps.utils.response_code import RET
from apps.util import login_required,verify_token
from apps.utils.send_phone_info import send_code_new

@api_mobile.route("/mobilceCollect",methods = ["POST"])
#@login_required
def mobile_collect_com():

    # token = request.headers["token"]
    # user = verify_token(token)
    # user_id = user.id
    user_id = 3
    req_dict = request.get_json()
    page = req_dict.get("page")
    per_page = req_dict.get("per_page")
    classify = req_dict.get("classify")
    choice = req_dict.get("choice")
    if not page:
        page = 1

    if not per_page:
        per_page = 10

    if not all([classify,choice]):
        return jsonify(code = RET.PARAMERR,msg= "数据不全")

    # 判断是企业还是行业关注，企业1，行业0
    if classify == 1:
        company = []
        try:
            user = User.query.get(user_id)
        except Exception as e:
            current_app.logger.error(e)
            return jsonify(code=RET.DBERR, msg="数据库错误")
        if choice == "2":
            try:
                maxnum = len(user.enterprise)
                company_list = user.enterprise[(page - 1) * per_page:page * per_page]
                for i in company_list:
                    create_time = UserEnterprise.query.filter_by(enterprise_id=i.id, user_id=user_id).first()
                    company.append({
                        "id": i.id,
                        "company_name": i.company_name,
                        "create_time": create_time.create_time.strftime('%Y-%m-%d'),
                        "build_date": i.build_date.strftime("%Y-%m-%d") if i.build_date else "-",
                        "legal":i.legal if i.legal else "-",
                        "money":"{}万元".format(i.capital_nums) if i.capital_nums else "-"
                    })
            except Exception as e:
                current_app.logger.error(e)
                return jsonify(code=RET.DBERR, msg="数据库错误")

            data = {
                "ob_list": company,
                "maxnum": maxnum
            }
            return jsonify(code=RET.OK, msg="查找成功", data=data)
        else:
            maxnum = len(user.company)
            company_list = user.company[(page - 1) * per_page:page * per_page]
            try:
                for i in company_list:
                    create_time = UserCompany.query.filter_by(company_id=i.id, user_id=user_id).first()
                    company.append({
                        "id": i.id,
                        "company_name": i.company_name,
                        "create_time": create_time.create_time.strftime('%Y-%m-%d'),
                        "build_date": i.build_date.strftime("%Y-%m-%d") if i.build_date else "-",
                        "legal":i.legal if i.legal else "-",
                        "money":"{}万元".format(i.capital_nums) if i.capital_nums else "-"
                    })
            except Exception as e:
                current_app.logger.error(e)
                return jsonify(code=RET.DBERR, msg="数据库错误")

            data = {
                "ob_list": company,
                "maxnum": maxnum
            }
            return jsonify(code=RET.OK, msg="查找成功", data=data)
    # 行业
    try:
        user = User.query.get(user_id)
        maxnum = len(user.industry)
        industry = []
        industry_list = user.industry[(page - 1) * per_page:page * per_page]
    except Exception as e:
        current_app.logger.error(e)
        return jsonify(code=RET.DBERR, msg="数据库错误")

    try:
        for i in industry_list:
            # 查询关注时间
            indu = UserIndustry.query.filter_by(industry_id=i.id, user_id=user_id).first()
            industry.append({
                "id": i.id,
                "industry_name": i.name,
                "create_time": indu.create_time.strftime("%Y-%m-%d"),
                "count": i.entities if i.entities else 0
            })
    except Exception as e:
        current_app.logger.error(e)
        return jsonify(code=RET.DBERR, msg="数据库错误")

    data = {
        "ob_list": industry,
        "maxnum": maxnum
    }
    return jsonify(code=200, msg="查找成功", data=data)



#取消收藏
@api_mobile.route("/mobileDelete", methods=["POST"])
@login_required
def mobile_delete():
    token = request.headers["token"]
    user = verify_token(token)
    user_id = user.id

    req_dict = request.get_json()

    id = req_dict.get("id")
    classify = req_dict.get("classify")
    choice = req_dict.get("choice")
    #print(id,classify,choice)
    if not all([id,classify,choice]):
        return jsonify(code=RET.PARAMERR, msg="数据不全")

    # id = g.id

    if classify == 1:
        if choice == "2":
        # 删除全国数据
                #pass
                try:
                    company_user = UserEnterprise.query.filter_by(enterprise_id=id, user_id=user_id).first()
                    db.session.delete(company_user)
                    db.session.commit()
                    return jsonify(code = RET.OK,msg = "取关成功")
                except Exception as e:
                    current_app.logger.error(e)
                    return jsonify(code=RET.DBERR, msg="数据库错误")
        else:
            try:
                company_user = UserCompany.query.filter_by(company_id=id, user_id=user_id).first()
                db.session.delete(company_user)
                db.session.commit()
                return jsonify(code = RET.OK,msg = "取关成功")
            except Exception as e:
                current_app.logger.error(e)
                return jsonify(code=RET.DBERR, msg="数据库错误")
    # 删除企业数据
    try:
        industry_user = UserIndustry.query.filter_by(industry_id=id, user_id=user_id).first()
        db.session.delete(industry_user)
        db.session.commit()
        return jsonify(code=RET.OK, msg="取关成功")
    except Exception as e:
        current_app.logger.error(e)
        return jsonify(code = RET.DBERR,msg = "数据库错误")